OpenShot Audio Library | OpenShotAudio: juce::OptionalScopedPointer< ObjectType > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::OptionalScopedPointer< ObjectType > Class Template Reference

`#include <juce_OptionalScopedPointer.h>`

## Public Member Functions
| OptionalScopedPointer ()=default
| OptionalScopedPointer (ObjectType *objectToHold, bool takeOwnership)
| OptionalScopedPointer (OptionalScopedPointer &objectToTransferFrom)
OptionalScopedPointer & | operator= (OptionalScopedPointer &objectToTransferFrom)
| ~OptionalScopedPointer ()
| operator ObjectType * () const noexcept
ObjectType * | get () const noexcept
ObjectType & | operator* () const noexcept
ObjectType * | operator-> () const noexcept
ObjectType * | release () noexcept
void | reset ()
void | clear ()
void | set (ObjectType *newObject, bool takeOwnership)
void | setOwned (ObjectType *newObject)
void | setNonOwned (ObjectType *newObject)
bool | willDeleteObject () const noexcept
void | swapWith (OptionalScopedPointer< ObjectType > &other) noexcept

## Detailed Description

template<class ObjectType>
class juce::OptionalScopedPointer< ObjectType >

Holds a pointer to an object which can optionally be deleted when this pointer goes out of scope.

This acts in many ways like a std::unique_ptr, but allows you to specify whether or not the object is deleted.

Definition at line 37 of file juce_OptionalScopedPointer.h.

## Constructor & Destructor Documentation

## ◆ OptionalScopedPointer() [1/3]

template<class ObjectType >

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( |  | ) |
| default

Creates an empty OptionalScopedPointer.

## ◆ OptionalScopedPointer() [2/3]

template<class ObjectType >

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | ObjectType * | objectToHold,
|  | bool | takeOwnership
| ) |  |
| inline

Creates an OptionalScopedPointer to point to a given object, and specifying whether the OptionalScopedPointer will delete it.

If takeOwnership is true, then the OptionalScopedPointer will act like a std::unique_ptr, deleting the object when it is itself deleted. If this parameter is false, then the OptionalScopedPointer just holds a normal pointer to the object, and won't delete it.

Definition at line 51 of file juce_OptionalScopedPointer.h.

## ◆ OptionalScopedPointer() [3/3]

template<class ObjectType >

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | OptionalScopedPointer< ObjectType > & | objectToTransferFrom | ) |
| inline

Takes ownership of the object that another OptionalScopedPointer holds.

Like a normal std::unique_ptr, the objectToTransferFrom object will become null, as ownership of the managed object is transferred to this object.

The flag to indicate whether or not to delete the managed object is also copied from the source object.

Definition at line 64 of file juce_OptionalScopedPointer.h.

## ◆ ~OptionalScopedPointer()

template<class ObjectType >

juce::OptionalScopedPointer< ObjectType >::~OptionalScopedPointer | ( |  | ) |
| inline

The destructor may or may not delete the object that is being held, depending on the takeOwnership flag that was specified when the object was first passed into an OptionalScopedPointer constructor.

Definition at line 94 of file juce_OptionalScopedPointer.h.

## Member Function Documentation

## ◆ clear()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::clear | ( |  | ) |
| inline

Does the same thing as reset().

Definition at line 130 of file juce_OptionalScopedPointer.h.

## ◆ get()

template<class ObjectType >

ObjectType * juce::OptionalScopedPointer< ObjectType >::get | ( |  | ) | const
| inlinenoexcept

Returns the object that this pointer is managing.

Definition at line 104 of file juce_OptionalScopedPointer.h.

Referenced by juce::OptionalScopedPointer< ObjectType >::set().

## ◆ operator ObjectType *()

template<class ObjectType >

juce::OptionalScopedPointer< ObjectType >::operator ObjectType * | ( |  | ) | const
| inlinenoexcept

Returns the object that this pointer is managing.

Definition at line 101 of file juce_OptionalScopedPointer.h.

## ◆ operator*()

template<class ObjectType >

ObjectType & juce::OptionalScopedPointer< ObjectType >::operator* | ( |  | ) | const
| inlinenoexcept

Returns the object that this pointer is managing.

Definition at line 107 of file juce_OptionalScopedPointer.h.

## ◆ operator->()

template<class ObjectType >

ObjectType * juce::OptionalScopedPointer< ObjectType >::operator-> | ( |  | ) | const
| inlinenoexcept

Lets you access methods and properties of the object that this pointer is holding.

Definition at line 110 of file juce_OptionalScopedPointer.h.

## ◆ operator=()

template<class ObjectType >

OptionalScopedPointer & juce::OptionalScopedPointer< ObjectType >::operator= | ( | OptionalScopedPointer< ObjectType > & | objectToTransferFrom | ) |
| inline

Takes ownership of the object that another OptionalScopedPointer holds.

Like a normal std::unique_ptr, the objectToTransferFrom object will become null, as ownership of the managed object is transferred to this object.

The ownership flag that says whether or not to delete the managed object is also copied from the source object.

Definition at line 78 of file juce_OptionalScopedPointer.h.

## ◆ release()

template<class ObjectType >

ObjectType * juce::OptionalScopedPointer< ObjectType >::release | ( |  | ) |
| inlinenoexcept

Removes the current object from this OptionalScopedPointer without deleting it. This will return the current object, and set this OptionalScopedPointer to a null pointer.

Definition at line 116 of file juce_OptionalScopedPointer.h.

## ◆ reset()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::reset | ( |  | ) |
| inline

Resets this pointer to null, possibly deleting the object that it holds, if it has ownership of it.

Definition at line 121 of file juce_OptionalScopedPointer.h.

Referenced by juce::OptionalScopedPointer< ObjectType >::clear(), juce::OptionalScopedPointer< ObjectType >::operator=(), juce::OptionalScopedPointer< ObjectType >::set(), and juce::OptionalScopedPointer< ObjectType >::~OptionalScopedPointer().

## ◆ set()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::set | ( | ObjectType * | newObject,
|  | bool | takeOwnership
| ) |  |
| inline

Makes this OptionalScopedPointer point at a new object, specifying whether the OptionalScopedPointer will take ownership of the object.

If takeOwnership is true, then the OptionalScopedPointer will act like a std::unique_ptr, deleting the object when it is itself deleted. If this parameter is false, then the OptionalScopedPointer just holds a normal pointer to the object, and won't delete it.

Definition at line 139 of file juce_OptionalScopedPointer.h.

Referenced by juce::OptionalScopedPointer< ObjectType >::setNonOwned(), and juce::OptionalScopedPointer< ObjectType >::setOwned().

## ◆ setNonOwned()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::setNonOwned | ( | ObjectType * | newObject | ) |
| inline

Makes this OptionalScopedPointer point at a new object, but will not take ownership of that object.

Definition at line 157 of file juce_OptionalScopedPointer.h.

## ◆ setOwned()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::setOwned | ( | ObjectType * | newObject | ) |
| inline

Makes this OptionalScopedPointer point at a new object, and take ownership of that object.

Definition at line 151 of file juce_OptionalScopedPointer.h.

## ◆ swapWith()

template<class ObjectType >

void juce::OptionalScopedPointer< ObjectType >::swapWith | ( | OptionalScopedPointer< ObjectType > & | other | ) |
| inlinenoexcept

Swaps this object with another OptionalScopedPointer. The two objects simply exchange their states.

Definition at line 171 of file juce_OptionalScopedPointer.h.

## ◆ willDeleteObject()

template<class ObjectType >

bool juce::OptionalScopedPointer< ObjectType >::willDeleteObject | ( |  | ) | const
| inlinenoexcept

Returns true if the target object will be deleted when this pointer object is deleted.

Definition at line 165 of file juce_OptionalScopedPointer.h.

The documentation for this class was generated from the following file:

- juce_OptionalScopedPointer.h